Subject: iSCSI TUF/PDU alignment - Procedural clarification

From: [email-masked]
Date: Fri, 11 Jan 2002 19:28:41 -0500

Jonathan Stone was quoted out of context in the original
message I sent.  With my apologies to Jonathan, here's the
complete context followed by text reflecting the context:

[Somesh Gupta]
> >I think the objections are to more to changing TCP wire
> >protocol (i.e. header) than to the implementation.

[.. snip ..]

[Jonathan Stone]
> I can, and do, change my TCP implementation.  The gotcha is that
> folding another operation into the existing loops in my TCP protocol--
> whether it's COBS or COWS or a CRC -- *IS* changing my TCP
> implementation.  Even if it doesn't change the on-the wire semantics,
> its still a change to my TCP.
> 
> In fact, it's easier for me to change my TCP to make it guarantee to
> preserve any segment boundaries between iSCSI PDUs[*], than it is to
> fold iSCSI-PDU processing into TCP processing.
> 
> 
> [*] when sending/retransmitting, that is.
> If we could guarantee that, hardware-accelerated receiers could use a
> TCP header option to indicate start-of-frame in this segment, and be
> done with it.  I'd even to go to bat with the transport-area
> representative, arguing that the ratio of iSCSI PDUs to expected drops
> is ``small enough'' that using that portion of the limited TCP option
> space for non-SACK usage was in fact a good trade-off.  (My
> understanding is that it's not really necessary to mark *all* PDU
> boundaries, just to mark enough of them to permit a reassembly buffer
> significantly smaller than BW*RTT, which therefore doesn't require
> lots of external SRAM; while still allowing direct data placement.)
> 
> I understand that  door is well and truly closed, though.

[David Black]

Indeed it is.

In general, TCP header options and changes to TCP sending behavior
are tsvwg topics, and further discussion of them should take place on
the tsvwg list rather than here.

Thanks,
--David

---------------------------------------------------
David L. Black, Senior Technologist
EMC Corporation, 42 South St., Hopkinton, MA  01748
+1 (508) 249-6449 *NEW*      FAX: +1 (508) 497-8500
[email-masked]         Cell: +1 (978) 394-7754
---------------------------------------------------